From b6ac73c068802a03bd967a1bdd66f072a2ce36fd Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Wed, 7 Dec 2011 14:25:59 -0600
Subject: Upgrade script for old manual items

---
 grade/report/grader/db/upgrade.php |   69 ++++++++++++++++++++++++++++++++++++
 grade/report/grader/version.php    |    3 +-
 2 files changed, 71 insertions(+), 1 deletions(-)
 create mode 100644 grade/report/grader/db/upgrade.php

diff --git a/grade/report/grader/db/upgrade.php b/grade/report/grader/db/upgrade.php
new file mode 100644
index 0000000..9cdbb4f
--- /dev/null
+++ b/grade/report/grader/db/upgrade.php
@@ -0,0 +1,69 @@
+<?php
+
+function xmldb_gradereport_grader_upgrade($oldversion) {
+
+    $upgrade = new gradereport_grader_upgrade(array(
+        new grader_manual_items()
+    ));
+
+    return $upgrade->from($oldversion);
+}
+
+abstract class gradereport_grader_upgrade_state {
+    var $version;
+
+    abstract function upgrade($db);
+
+    function __invoke($db) {
+        return $this->upgrade($db);
+    }
+}
+
+class grader_manual_items extends gradereport_grader_upgrade_state {
+    var $version = 2011120801;
+
+    function upgrade($db) {
+        $sql = "UPDATE {grade_grades} gr, {grade_items} gi
+            SET gr.rawgrade = gr.finalgrade
+            WHERE gi.id = gr.itemid AND gi.itemtype = 'manual'";
+
+        return $db->execute($sql);
+    }
+}
+
+class gradereport_grader_upgrade {
+    function __construct($upgrades) {
+        $this->upgrades = $upgrades;
+    }
+
+    function from($oldversion) {
+        global $DB;
+
+        // Oldest upgrade first
+        usort($this->upgrades, function($a, $b) {
+            $diff = ($a->version < $b->version) ? -1 : 1;
+            return ($a->version == $b->version) ? 0 : $diff;
+        });
+
+        $result = true;
+
+        foreach ($this->upgrades as $upgrade) {
+            if (!$result) continue;
+
+            if ($oldversion < $upgrade->version and is_callable($upgrade)) {
+
+                try {
+                    $success = $upgrade($DB);
+
+                    $result = ($result and $success);
+                } catch (Exception $e) {
+                    $result = false;
+                }
+
+                upgrade_plugin_savepoint($result, $upgrade->version, 'gradereport', 'grader');
+            }
+        }
+
+        return $result;
+    }
+}
diff --git a/grade/report/grader/version.php b/grade/report/grader/version.php
index 14c2e50..bf50771 100644
--- a/grade/report/grader/version.php
+++ b/grade/report/grader/version.php
@@ -25,6 +25,7 @@
 
 defined('MOODLE_INTERNAL') || die();
 
-$plugin->version   = 2011112900;        // The current plugin version (Date: YYYYMMDDXX)
+$plugin->version   = 2011120801;
 $plugin->requires  = 2011112900;        // Requires this Moodle version
 $plugin->component = 'gradereport_grader'; // Full name of the plugin (used for diagnostics)
+
-- 
1.7.1


